      !***********************************************************************!
      SUBROUTINE  pmv(  a,  b  )
      !***********************************************************************!
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration  des  arguments
!
!Vecteur resultat,  donnee partielle
      REAL(rp),  DIMENSION(sx-1:ex+1,sy-1:ey+1,sz-1:ez+1),  INTENT(OUT)  ::  a
!
!Vecteur en entree,  donnee complete
      REAL(rp),  DIMENSION(sx-1:ex+1,sy-1:ey+1,sz-1:ez+1),  INTENT(IN)    ::  b
!
!--Declaration des variales locales
!
! Poids
      REAL(rp)  ::  c1, c2, c3, c4
!
!Compteurs
      INTEGER   ::  i,  j,  k
!
!
      !***********************************************************************!
!
      c1 = one / hx**2
      c2 = one / hy**2
      c3 = one / hz**2
      c4 = -2.0_rp * ( c1 + c2 + c3 )
!
      DO  k  =  sz,  ez
          DO  j  =  sy,  ey
             DO  i  =  sx,  ex
!
               a(i,j,k) = &
               c1 * ( b(i+1,j  ,k  ) + b(i-1,j  ,k  ) ) &
             + c2 * ( b(i  ,j+1,k  ) + b(i  ,j-1,k  ) ) &
             + c3 * ( b(i  ,j  ,k+1) + b(i  ,j  ,k-1) ) &
             + c4 * b(i,j,k)
            END  DO
         END  DO
      END  DO
!
      RETURN
      END SUBROUTINE pmv
